//+------------------------------------------------------------------+
//|                                             VininI_LineStat2.mq4 |
//|                               Copyright  2010, Victor Nicolaev. |
//|                                                    vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Victor Nicolaev."
#property link      "vinin@mail.ru"


#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_width1 2

extern int     BarsCount=15; //     ZZ
//  
double ZZ[];
double ZZU[];

static int ZZTime[2]={0,0};
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init() {
   SetIndexBuffer(0, ZZ);      
   SetIndexBuffer(1, ZZU);      
               
   //     
   if (BarsCount<2) BarsCount=2;

   SetIndexStyle(0, DRAW_SECTION);   
   SetIndexStyle( 1, DRAW_ARROW);   
   SetIndexArrow( 1, 108);

   SetIndexLabel(0, "ZZ");

  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   Comment("");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int counted_bars=IndicatorCounted();
   int limit=Bars-counted_bars-1;
   if(Bars-BarsCount > 2) {
      ArrayInitialize(ZZ,EMPTY_VALUE);
      ArrayInitialize(ZZU,EMPTY);
      limit=Bars-BarsCount-1;
      int posHigh = iHighest( NULL, 0, MODE_HIGH, BarsCount, limit);   
      int posLow  = iLowest(  NULL, 0, MODE_LOW,  BarsCount, limit);
      ZZ[posHigh]=High[posHigh];
      ZZ[posLow]=Low[posLow];
      ZZTime[0]=MathMax(Time[posHigh],Time[posLow]);
      ZZTime[1]=MathMin(Time[posHigh],Time[posLow]);
   }
   
   for(int i=limit; i>=0; i--) {
      double tmp= ZZWork(ZZ, i);
      if (tmp>0) ZZU[i]=tmp; else ZZU[i]=ZZU[i+1];
   }
   return(0);
}


double ZZWork(double &ZZ[], int pos){



   int posHigh = iHighest( NULL, 0, MODE_HIGH, BarsCount, pos);   
   int posLow  = iLowest(  NULL, 0, MODE_LOW,  BarsCount, pos);
   int prevpos1=iBarShift(NULL,0,ZZTime[0]);
   int prevpos2=iBarShift(NULL,0,ZZTime[1]);

   int posmax,posmin;
   double Valuemax, Valuemin;


   if (posHigh>posLow) {
      posmax=posHigh;
      posmin=posLow;
      Valuemax=High[posHigh];
      Valuemin=Low[posLow];
   } else {
      posmax=posLow;
      posmin=posHigh;
      Valuemin=High[posHigh];
      Valuemax=Low[posLow];
   }
   
   if (prevpos1>posmax) {
      if ((ZZ[prevpos2]-ZZ[prevpos1])*(ZZ[prevpos1]-Valuemax)>=0) {
         ZZ[prevpos1]=EMPTY_VALUE;
      } else {
         ZZTime[1]=ZZTime[0];
      }
      ZZ[posmax]=Valuemax;
      ZZTime[0]=Time[posmax];
      return(Valuemax);
   } 
   if (prevpos1>posmin) {
      if ((ZZ[prevpos2]-ZZ[prevpos1])*(ZZ[prevpos1]-Valuemin)>=0) {
         ZZ[prevpos1]=EMPTY_VALUE;
      } else {
         ZZTime[1]=ZZTime[0];
      }
      ZZ[posmin]=Valuemin;
      ZZTime[0]=Time[posmin];
      return(Valuemin);
   } 
   return(0);
}